chiark / gitweb /
test suite: run-all: Minor refactoring etc.
authorIan Jackson <ijackson@chiark.greenend.org.uk>
Thu, 26 Jul 2018 05:35:31 +0000 (06:35 +0100)
committerIan Jackson <ijackson@chiark.greenend.org.uk>
Thu, 26 Jul 2018 09:04:30 +0000 (10:04 +0100)
* Makefile: Move the DGIT_TEST_RETRY_COUNT if/else into the rule.
  This removes a small amount of duplication.

* run-all: Document the option to pass explicitly list of scripts.

* run-all: Add an option parser, which currently supports no options.

Signed-off-by: Ian Jackson <ijackson@chiark.greenend.org.uk>
tests/Makefile
tests/run-all

index e6ce153bae615795e3dacc51ceafd1b324ab1353..44b745849153b22b13041666efa5a4aec168ea2a 100644 (file)
@@ -12,14 +12,11 @@ all: $(foreach t,$(TESTNAMES),tests/tmp/$t.ok)
 tests/tmp:
        mkdir -p $@
 
-ifeq ($(DGIT_TEST_RETRY_COUNT),)
 
 tests/tmp/%.ok: tests/tmp
+ifeq ($(DGIT_TEST_RETRY_COUNT),)
        tests/tests/$* >tests/tmp/$*.log 2>&1
-
 else
-
-tests/tmp/%.ok: tests/tmp
        @for retry in $$( seq 1 $(DGIT_TEST_RETRY_COUNT) ); do          \
                echo "[$$retry] $*";                                    \
                tests/tests/$* >tests/tmp/$*.$$retry.log 2>&1;          \
@@ -27,5 +24,4 @@ tests/tmp/%.ok: tests/tmp
                if [ $$rc = 0 ]; then exit 0; fi;                       \
                echo >&2 "[$$retry] $* TEST FAILED $$rc";               \
        done; exit $$rc
-
 endif
index f72b9fae7d0958d490213027070c2736da87bc98..3e40369eeb601900f329e4d14457c362c30160d3 100755 (executable)
@@ -1,10 +1,18 @@
 #!/bin/bash
 set -e
 # convenience script for running the tests outside adt-run
-# usage: tests/using-intree tests/run-all
+# usage: tests/using-intree tests/run-all [tests/tests/*]
 
 set -o pipefail
 
+while [ $# != 0 ]; do
+       case "$1" in
+       --)                     shift; break ;;
+       -*)     echo >&2 "run-all: unknown option $1"; exit 20 ;;
+       *)                      break ;;
+       esac
+done
+
 ncpus=$(nproc || echo 1)
 jcpus=-j$(( ncpus * 134 / 100 ))